/*************************************************************************

 **************************************************************************/

package simple.dcsp.abtfamily.abthyb;

import kernel.AbstractAgent;
import kernel.StopException;
import kernel.com.Message;
import simple.Nogood;
import util.Commands;
import util.IntArray;
import util.VarAssignment;

public class OkMessageHandler extends simple.dcsp.abtfamily.abt.OkMessageHandler {

	public OkMessageHandler(AbstractAgent agent) {
		super(agent);
	}

	/**
	 * @param msg
	 */
	public void processMessage(Message msg) throws StopException {
		VarAssignment senderAss = (VarAssignment) msg.get(Commands.OK);
		int cmp = this.myAgent.agentView.compareTimeCounter(senderAss);
		if (cmp >= 0) {
			this.myAgent.agentView.priorityMerge(senderAss);
			Nogood ng = ((ABTHybAgent) this.myAgent).lastNogood;
			int s = msg.getSenderId();
			if(((ABTHybAgent) this.myAgent).wait){
				if(s==ng.getRhsAgentId() || (ng.getLhs().contains(senderAss.getVarIdentifier()) && cmp > 0)){
					((ABTHybAgent) this.myAgent).wait = false;
				}
			}
			if(!((ABTHybAgent) this.myAgent).wait){
				((ABTHybAgent) this.myAgent).checkAgentView();
			}
		} else {
			this.myAgent.auxiliaryStatistics.get(Commands.ObsoleteOk).value++;
		}
	}

	/**
	 * 
	 */
	public void sendOkMessages() {
		IntArray lowerNeighbors = this.myAgent.communicator.getLowerNeighbors();
		for (int i = 0 ; i < lowerNeighbors.size() ; i++) {
			this.sendOkMessage(lowerNeighbors.get(i));
		}
	}

	/**
	 * 
	 */
	public void sendOkMessage(int receiverId) {
		VarAssignment myVarAss = ((ABTHybAgent) this.myAgent).var.getVarAssignment();
		Message msg = this.createMessage();
		msg.addContents(Commands.OK, myVarAss);
		msg.setReceiverId(receiverId);
		((ABTHybAgent) this.myAgent).storeStatisticsFor(msg);
		this.myAgent.sendMessage(msg);
	}

}
