/*************************************************************************

 **************************************************************************/

package simple.dcsp.agile.exp;

import kernel.StopException;
import kernel.com.Message;
import kernel.com.MessageHandler;
import util.Commands;
import util.Instantiation;
import util.IntArray;
import util.Tools;
import util.VarAssignment;

public class OkMsgHandler extends MessageHandler {

	public OkMsgHandler(AgileAgent agent) {
		super(agent, Commands.OK);
	}

	/**
	 * @param msg
	 */
	public void processMessage(Message msg) throws StopException {
		VarAssignment ass = (VarAssignment) msg.get(Commands.OK);
		IntArray order = (IntArray) msg.get(Commands.ORDER);
		double[] TV = Tools.DoubleArrayFromString("" + msg.get(AgileAgent.TV));
		((AgileAgent) this.myAgent).checkOrder(order, TV);
		Instantiation lhs = (Instantiation) msg.get(Commands.LHS);
		int rhs = (Integer) msg.get(Commands.RHS);
		((AgileAgent) this.myAgent).updateAgentView(lhs, ass);
		((AgileAgent) this.myAgent).setExplanation(msg.getSenderId(), lhs, rhs);
		((AgileAgent) this.myAgent).CheckAgentView();
	}

	/**
	 * 
	 */
	public void sendOkMessages() {
		Instantiation lhs = ((AgileAgent) this.myAgent).getExplanationLhs();
		int rhs = ((AgileAgent) this.myAgent).getExplanationRhs();
		IntArray receivers = null;
		if (((AgileAgent) this.myAgent).onlyToNeighbors) {
			receivers = this.myAgent.communicator.getLowerNeighbors();
		} else {
			receivers = this.myAgent.agentOrder.getLowerAgents();
		}
		for (int lower : receivers) {
			this.sendOkMessage(lower, lhs, rhs);
		}
		((AgileAgent) this.myAgent).IchangeMyOrder = false;
	}

	/**
	 * 
	 * @param neig
	 * @param myExp
	 */
	public void sendOkMessage(int neig, Instantiation lhs, int rhs) {
		IntArray myOrder = this.myAgent.getOrder();
		String myTV = Tools.arrayToString(((AgileAgent) this.myAgent).myTV);
		Message msg = this.createMessage();
		msg.addContents(Commands.OK, ((AgileAgent) this.myAgent).var.getVarAssignment());
		msg.addContents(Commands.LHS, lhs);
		msg.addContents(Commands.RHS, rhs);
		msg.addContents(Commands.ORDER, myOrder);
		msg.addContents(AgileAgent.TV, myTV);
		msg.setReceiverId(neig);
		((AgileAgent) this.myAgent).storeStatisticsFor(msg);
		this.myAgent.sendMessage(msg);
	}

}
