package simple.dcsp.sbt;

import java.util.Iterator;

import kernel.AbstractVar;
import kernel.Constraint;
import kernel.ConstraintsHandler;
import kernel.Variable;
import simple.SimpleAgent;

public class SBTConstraintsHandler extends ConstraintsHandler {

	/**
	 * Constructor of SBT constraint handler class
	 */
	public SBTConstraintsHandler(SimpleAgent agent) {
		super(agent);
	}

	public void postConstraints() {
		Iterator<Constraint> it = this.getConstraintsIterator();
		while (it.hasNext()) {
			Constraint exC = it.next();
			if (exC.getNbExternalVars() == 0) {
				this.post(exC);
			}
			for (int i = 0 ; i < exC.getNbExternalVars() ; i++) {
				AbstractVar exV = exC.getExternalVar(i);
				if (this.myAgent.agentOrder.isHigher(exV.getAgentId())) {
					this.post(exC);
					break;
				}
			}
		}
	}

	@Override
	public void processConstraint(Constraint c, Variable v, int evtType) {
		c.awakeOnVariableEvent(v, evtType);
	}

}
