package simulation;

import java.io.File;

import org.jdom.Document;
import org.jdom.Element;
import org.jdom.input.SAXBuilder;

import benchmark.graphcoloring.URGCGenerator;
import benchmark.meetingscheduling.URMeetingScheduling;
import benchmark.nqueen.NQueenGenerator;
import benchmark.random.RBCDisCSPGenerator;
import benchmark.random.RBDisCSPGenerator;
import benchmark.rmsp.RandomMSP;
import benchmark.sensornetwork.SensorDCSPGenerator;
import util.Commands;

/**
 * 
 * @authors 
 * <a href="mailto:ezzahir@ensa-agadir.ac.ma?subject=DisChoco &cc=wahbi@lirmm.fr &cc=bessiere@lirmm.fr">Redoaune Ezzahir</a> and 
 * <a href="mailto:wahbi@lirmm.fr?subject=DisChoco &cc=ezzahir@ensa-agadir.ac.ma &cc=bessiere@lirmm.fr">Mohamed Wahbi</a>
 */
public class Experimentation {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
//		util.Logger.LOG_DEBUG = true;
//		util.Logger.log_debug_level = util.Logger.INFO_LEVEL;
		String path = "./samples/GC/test25.xml";
		path = "./samples/tmp/test.xml";
		path = "./samples/tmp/afcngtrng_5_2.xml";
		String[] arg = {path};
		args = arg;
		new Experimentation(args);
	}

	public Experimentation(String[] args) {

		File file = new File(args[0]);
		Document document = null;
		SAXBuilder sxb = new SAXBuilder();
		try {
			document = sxb.build(file);
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(0);
		}
		Element root = document.getRootElement();
		String type = root.getAttributeValue(Commands.type);
		if (type.equals(Commands.RandomTKC) || type.equals(Commands.RandomPKC)) {
			RBDisCSPGenerator.lunchXP(file);
			return;
		} else if (type.equals(Commands.GraphColoring)) {
			URGCGenerator.lunchXP(file);
			return;
		} else if (type.equals(Commands.NQueen)) {
			NQueenGenerator.lunchXP(file);
			return;
		} else if (type.equals(Commands.ComplexRandomTKC)) {
			RBCDisCSPGenerator.lunchXP(file);
			return;
		} else if (type.equals(Commands.SensorNetworks)) {
			SensorDCSPGenerator.lunchXP(file);
			return;
		} else if (type.equals(Commands.MeetingScheduling)) {
			URMeetingScheduling.lunchXP(file);
			return;
		} else if (type.equals(Commands.RMSP)) {
			RandomMSP.lunchXP(file);
			return;
		}
	}
}
