package util.graph;

import java.util.StringTokenizer;

/**
 * each node has an Id (agentID) and associated Integer
 **/

public class PriorityNode {

	protected int Id;

	protected int priority;

	// -----------------------------------------------------------------------//
	public PriorityNode(int agentId, int priority) {
		this.Id = agentId;
		this.priority = priority;
	}

	/**
	 * Returns a string representation of this object
	 */
	public String toString() {
		StringBuffer sb = new StringBuffer();
		sb.append("(" + Id + ",");
		sb.append(priority + ")");
		return sb.toString();
	}

	// -----------------------------------------------------------------------//
	public int getNodeId() {
		return Id;
	}

	// -----------------------------------------------------------------------//
	public int getPriority() {
		return priority;
	}

	/**
	 *parse string of the form "ageID,num"
	 */
	// -----------------------------------------------------------------------//
	public static PriorityNode fromString(String str) {
		StringTokenizer stok = new StringTokenizer(str, ",");
		int agentId = Integer.parseInt(stok.nextToken().trim());
		int NodeNum = Integer.parseInt(stok.nextToken().trim());
		PriorityNode result = new PriorityNode(agentId, NodeNum);
		return result;
	}
}
